/*
 *    AulaChat - Advanced teacher/pupil communication system
 *    Copyright (C) 2006 James Lpez Prieto (BLuEGoD).
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *    
 *    Modulo: Gestion web / Servicios web
 *
 */
#ifndef WEB_H
#define WEB_H

#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <unistd.h>
#include <ctype.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fnmatch.h>
#include <libgen.h>
#include <signal.h>
#include <errno.h>

#include <signal.h> //necesario para sigaction

#define MAXBUFG 1024 //tamao buffer lectura
#define ALARMA_TIME 1 //tiempo espera desbloqueo en llamadas a read

int sck; // en principio global. (Debido a un posible uso continuado).

int web(int *, char *); //-Inicializacion- Llama a las funciones gosock y superloop
int gosock(int *); //Genera la 'escucha' en el puerto indicado
/* -- Bucle principal -- (superloop)
 * - Se crea un socket para cada cliente
 * - Se 'forkea' (crea un proceso) cada cliente
 * - Se intereaciona con el cliente mediante las funciones
 * - Se cierra la conexin
 */
int superloop(const char *); 

int pide(int *, const char *, char *); //Se lee un envo desde un cliente web
size_t coje(char *); //retorna tamao del fichero a leer
int coje2(char *, void *, size_t *); //abre el fichero y comprueba error
int da(int *, void *, char *, size_t *); //envia el/los fichero/datos pedidos

/* Gestiona el envo de las web que accede un administrador global */
int web_admin_global(void *,int *); 

//Envia un mensaje de error y cierra la conexin si es necesario
void er(const char *,int *); 

//Se genera un mensaje de error para enviar al cliente
//conforme la pgina no existe/no ha sido encontrada
void s400(int *); 

//Complementos de la funcin pide para gestionar un envo web POST
void alarma(int sig);
struct sigaction newac;

#endif
